gsup.h File Reference
Generic Subscriber Update Protocol
`#include <stdint.h>`
`#include <osmocom/core/msgb.h>`
`#include <osmocom/gsm/protocol/gsm_23_003.h>`
`#include <osmocom/gsm/protocol/gsm_04_08_gprs.h>`
`#include <osmocom/crypt/auth.h>`

Go to the source code of this file.

## Data Structures

struct | osmo_gsup_pdp_info
| parsed/decoded PDP context information More...
struct | osmo_gsup_message
| parsed/decoded GSUP protocol message More...

## Macros

#define | OSMO_GSUP_PORT 4222
#define | OSMO_GSUP_MAX_NUM_PDP_INFO 10 /* GSM 09.02 limits this to 50 */
| Maximum nubmer of PDP inside osmo_gsup_message. More...
#define | OSMO_GSUP_MAX_NUM_AUTH_INFO 5
| Maximum number of auth info inside osmo_gsup_message. More...
#define | OSMO_GSUP_MAX_MSISDN_LEN 9
| Maximum number of octets encoding MSISDN in BCD format. More...
#define | OSMO_GSUP_MAX_CALLED_PARTY_BCD_LEN 43 /* TS 24.008 10.5.4.7 */
#define | OSMO_GSUP_PDP_TYPE_SIZE 2
#define | OSMO_GSUP_IS_MSGT_REQUEST(msgt) (((msgt) & 0b00000011) == 0b00)
#define | OSMO_GSUP_IS_MSGT_ERROR(msgt) (((msgt) & 0b00000011) == 0b01)
#define | OSMO_GSUP_TO_MSGT_ERROR(msgt) (((msgt) & 0b11111100) | 0b01)

## Enumerations

enum

osmo_gsup_iei {
OSMO_GSUP_IMSI_IE = 0x01,
OSMO_GSUP_CAUSE_IE = 0x02,
OSMO_GSUP_AUTH_TUPLE_IE = 0x03,
OSMO_GSUP_PDP_INFO_COMPL_IE = 0x04,
OSMO_GSUP_PDP_INFO_IE = 0x05,
OSMO_GSUP_CANCEL_TYPE_IE = 0x06,
OSMO_GSUP_FREEZE_PTMSI_IE = 0x07,
OSMO_GSUP_MSISDN_IE = 0x08,
OSMO_GSUP_HLR_NUMBER_IE = 0x09,
OSMO_GSUP_PDP_CONTEXT_ID_IE = 0x10,
OSMO_GSUP_PDP_TYPE_IE = 0x11,
OSMO_GSUP_ACCESS_POINT_NAME_IE = 0x12,
OSMO_GSUP_PDP_QOS_IE = 0x13,
OSMO_GSUP_CHARG_CHAR_IE = 0x14,
OSMO_GSUP_RAND_IE = 0x20,
OSMO_GSUP_SRES_IE = 0x21,
OSMO_GSUP_KC_IE = 0x22,
OSMO_GSUP_IK_IE = 0x23,
OSMO_GSUP_CK_IE = 0x24,
OSMO_GSUP_AUTN_IE = 0x25,
OSMO_GSUP_AUTS_IE = 0x26,
OSMO_GSUP_RES_IE = 0x27,
OSMO_GSUP_CN_DOMAIN_IE = 0x28,
OSMO_GSUP_SESSION_ID_IE = 0x30,
OSMO_GSUP_SESSION_STATE_IE = 0x31,
OSMO_GSUP_SS_INFO_IE = 0x35
}

| Information Element Identifiers for GSUP IEs. More...

enum

osmo_gsup_message_type {
OSMO_GSUP_MSGT_UPDATE_LOCATION_REQUEST = 0b00000100,
OSMO_GSUP_MSGT_UPDATE_LOCATION_ERROR = 0b00000101,
OSMO_GSUP_MSGT_UPDATE_LOCATION_RESULT = 0b00000110,
OSMO_GSUP_MSGT_SEND_AUTH_INFO_REQUEST = 0b00001000,
OSMO_GSUP_MSGT_SEND_AUTH_INFO_ERROR = 0b00001001,
OSMO_GSUP_MSGT_SEND_AUTH_INFO_RESULT = 0b00001010,
OSMO_GSUP_MSGT_AUTH_FAIL_REPORT = 0b00001011,
OSMO_GSUP_MSGT_PURGE_MS_REQUEST = 0b00001100,
OSMO_GSUP_MSGT_PURGE_MS_ERROR = 0b00001101,
OSMO_GSUP_MSGT_PURGE_MS_RESULT = 0b00001110,
OSMO_GSUP_MSGT_INSERT_DATA_REQUEST = 0b00010000,
OSMO_GSUP_MSGT_INSERT_DATA_ERROR = 0b00010001,
OSMO_GSUP_MSGT_INSERT_DATA_RESULT = 0b00010010,
OSMO_GSUP_MSGT_DELETE_DATA_REQUEST = 0b00010100,
OSMO_GSUP_MSGT_DELETE_DATA_ERROR = 0b00010101,
OSMO_GSUP_MSGT_DELETE_DATA_RESULT = 0b00010110,
OSMO_GSUP_MSGT_LOCATION_CANCEL_REQUEST = 0b00011100,
OSMO_GSUP_MSGT_LOCATION_CANCEL_ERROR = 0b00011101,
OSMO_GSUP_MSGT_LOCATION_CANCEL_RESULT = 0b00011110,
OSMO_GSUP_MSGT_PROC_SS_REQUEST = 0b00100000,
OSMO_GSUP_MSGT_PROC_SS_ERROR = 0b00100001,
OSMO_GSUP_MSGT_PROC_SS_RESULT = 0b00100010
}

| GSUP message type. More...
enum | osmo_gsup_cancel_type { OSMO_GSUP_CANCEL_TYPE_UPDATE = 1, OSMO_GSUP_CANCEL_TYPE_WITHDRAW = 2 }
enum | osmo_gsup_cn_domain { OSMO_GSUP_CN_DOMAIN_PS = 1, OSMO_GSUP_CN_DOMAIN_CS = 2 }
enum | osmo_gsup_session_state { OSMO_GSUP_SESSION_STATE_NONE = 0x00, OSMO_GSUP_SESSION_STATE_BEGIN = 0x01, OSMO_GSUP_SESSION_STATE_CONTINUE = 0x02, OSMO_GSUP_SESSION_STATE_END = 0x03 }
| TCAP-like session state. More...

## Functions

static const char * | osmo_gsup_message_type_name (enum osmo_gsup_message_type val)
static const char * | osmo_gsup_session_state_name (enum osmo_gsup_session_state val)
int | osmo_gsup_decode (const uint8_t *const_data, size_t data_len, struct osmo_gsup_message *gsup_msg)
| Decode (parse) a GSUP message. More...
int | osmo_gsup_encode (struct msgb *msg, const struct osmo_gsup_message *gsup_msg)
| Encode a GSUP message. More...
int | osmo_gsup_get_err_msg_type (enum osmo_gsup_message_type type_in)
| return the error message type corresponding to type_in More...

## Variables

const struct value_string | osmo_gsup_message_type_names []
const struct value_string | osmo_gsup_session_state_names []

## Detailed Description

Osmocom Generic Subscriber Update Protocol message encoder/decoder.